/**
 * Created by Crystian on 5/18/2015.
 */

var app = (function () {

	var table = document.getElementById('table'),
		result = document.getElementById('result'),
		desc1 = document.getElementById('desc1'),
		desc2 = document.getElementById('desc2'),
		btnReset = document.getElementById('btnReset'),
		btnFullReset = document.getElementById('btnFullReset'),
		btnContinue = document.getElementById('btnContinue'),
		btnRetry = document.getElementById('btnRetry'),
		counterLabel1 = document.getElementById('counterLabel1'),
		counterLabel2 = document.getElementById('counterLabel2'),

		options = [],
		optionsSelected = [],
		showNumbers = true,

		learnMax = 4,
		successMax = 3,
		level = 0,
		success = 0,
		tried = 0;


	function msg(m) {
		navigator.notification.alert(m);
	}

	function init() {
		if (localStorage.length===0) {
			msg('Experimiento 701: "Drill method"\nGracias por participar en esta prueba sujeto! Seras testigo de la evolucion del aprendizaje, muchas gracias por participar, esto no podria hacerlo sin vos!');
		}

		mixpanel.track("App Loaded");
		FastClick.attach(document.body);

		options = get('options') || [];

		if (options.length === 0) {
			var validOptions = _.shuffle(['VERDE', 'AZUL', 'GRIS', 'CELESTE', 'NARANJA', 'ROJO']);

			_.map(validOptions, function (value, index) {
				options.push({id: index + 1, color: value});
			});

			save('options', options);
		}

		level = parseInt(get('level', level));
		success = parseInt(get('success', success));
		tried = parseInt(get('tried', tried));

		setSuccess(success);

		reset();
	}

	function userReset(m){
		reg(m);
		reset();
	}

	function reg(desc){
		mixpanel.track(desc, {level: level, tried: tried});
	}

	function reset() {
		var hiddenClass = 'hidden';
		desc1.classList.add(hiddenClass);
		desc2.classList.add(hiddenClass);
		btnReset.classList.add(hiddenClass);
		btnContinue.classList.add(hiddenClass);
		btnRetry.classList.add(hiddenClass);
		optionsSelected = [];

		switch (level){
			case 0:
				desc1.classList.remove(hiddenClass);
				showNumbers = true;
				break;
			default:
				desc2.classList.remove(hiddenClass);
				showNumbers = false;
				break;
		}

		clearResult();
		createTable();
	}

	function clearResult() {
		result.innerHTML = '';
	}

	function createTable() {
		var optionsRandom = _.chunk(_.shuffle(options), 2),
			r = '';

		_.map(optionsRandom, function (o) {
			r += '<div  class="classMain">';
			_.map(o, function (o2) {
				var num = showNumbers ? o2.id : '';
				//var num = o2.id;
				r += '<div class="els"><button class="btn-lg btn-' + o2.color + '" onclick="app.pushed(this, ' + o2.id + ')">' + num + '</button></div>';
			});
			r += '</div><div class="clearfix"></div>';
		});

		table.innerHTML = r;
	}

	function pushed(el, id) {
		el.classList.add('disabled');
		el.disabled = true;

		var o = _.find(options, {'id': id});
		optionsSelected.push(o);
		result.innerHTML += '<li><span class="label label-' + o.color + '">' + o.color + '</span>&nbsp;<span id="r' + o.id + '"></span></li>';

		checkResult();
	}

	function notify(hours){
		var now = new Date().getTime(),
			time_to = new Date(now + (hours * 1000 * 60 * 60));

		var sound = device.platform == 'Android' ? 'file://sound.mp3' : 'file://beep.caf';

		cordova.plugins.notification.local.schedule({
			id: 1,
			title: 'Vamos que falta poco!',
			text: 'Hora de continuar con el test!',
			at: time_to,
			sound: sound,
			badge: 12
		});

		cordova.plugins.notification.local.on("click", function (notification) {
			//notification.data;
			console.info('atendio!');
		});
	}

	function checkResult() {
		//end
		if (optionsSelected.length === options.length) {
			btnReset.classList.add('hidden');

			var perfect = true;
			_.map(options, function(v, index) {
				var r = '';

				if (v.id === optionsSelected[index].id) {
					r = '<span class="resultSuccess">&#10004;</span>';
				} else {
					r = '<span class="resultFail">&#10008;</span>';
					perfect = false;
				}
				document.getElementById('r' + v.id).innerHTML = r;
			});

			tried++;
			save('tried',tried);

			if (perfect) {
				btnContinue.classList.remove('hidden');
				success++;

				debugger;

				if (success === (level === 0 ? learnMax : successMax)) {
					reg('success');

					level++;
					level = save('level', level);
					tried = save('tried', 0);
					success = setSuccess(0);

					switch (level){
						case 1:
							msg('Bien hecho!!\nAhora intentar pulsar los colores en ese mismo orden');
							break;
						case 2:
							msg('Excelente!, una vez mas');
							break;
						case 3:
							msg('Bien hecho!!\nTe lo aprendiste!, ahora hace esto mismo dentro de una hora aprox a ver si aun recordas (te lo voy a "notificar" para que no te olvides, tranca)');
							notify(1);
							break;
						case 4:
							var m = ', en dos horas te vuelvo a molestar con la ultima';
							if(tried>1){
								msg('Excelente!\nTe lo acordaste! (ponele), de nuevo gracias!'+ m);
							} else {
								msg('Excelente!\nTe lo acordaste!, de nuevo gracias!'+ m);
							}
							notify(1);
							break;
						default:
							msg('LISTO!, ya no hace falta mas, gracias por participar!');
					}

				} else {
					setSuccess(success);
				}

				reset();

			} else {
				btnRetry.classList.remove('hidden');
			}

		} else {
			btnReset.classList.remove('hidden');
		}
	}

	function fullReset() {
		var sure = confirm('seguro que queres resetear? se perdera la relacion numeros-colores!');
		if (sure) {
			localStorage.clear();
			reg("ResetFull");
			level = 0;
			init();
		}
	}

	function setSuccess(n) {
		var falta = (level === 0 ? learnMax : successMax) - n;
		counterLabel1.innerHTML = falta;
		counterLabel2.innerHTML = falta;
		save('success', n);
		return n;
	}

	function save(key, value) {
		localStorage.setItem(key, JSON.stringify(value));
		return value;
	}

	function get(key, def) {
		var r = localStorage.getItem(key);
		try {
			r = JSON.parse(r);
		} catch (e) {}

		return r || def;
	}

	return {
		fullReset: fullReset,
		userReset: userReset,
		reset: reset,
		pushed: pushed,
		init: init
	}
}());



